/* MB9BF618T 쥸 */

#define ClockResetBase  0x40010000
#define SCM_CTL         (ClockResetBase + 0x00)
#define SCM_STR         (ClockResetBase + 0x04)
#define STB_CTL         (ClockResetBase + 0x08)
#define RST_STR         (ClockResetBase + 0x0c)
#define BSC_PSR         (ClockResetBase + 0x10)
#define APBC0_PSR       (ClockResetBase + 0x14)
#define APBC1_PSR       (ClockResetBase + 0x18)
#define APBC2_PSR       (ClockResetBase + 0x1c)
#define SWC_PSR         (ClockResetBase + 0x20)
#define TTC_PSR         (ClockResetBase + 0x28)
#define CSW_TMR         (ClockResetBase + 0x30)
#define PSW_TMR         (ClockResetBase + 0x34)
#define PLL_CTL1        (ClockResetBase + 0x38)
#define PLL_CTL2        (ClockResetBase + 0x3c)
#define CSV_CTL         (ClockResetBase + 0x40)
#define CSV_STR         (ClockResetBase + 0x44)
#define FCSWH_CTL       (ClockResetBase + 0x48)
#define FCSWL_CTL       (ClockResetBase + 0x4c)
#define FCSWD_CTL       (ClockResetBase + 0x50)
#define DBWDT_CTL       (ClockResetBase + 0x54)
#define INT_ENR         (ClockResetBase + 0x60)
#define INT_STR         (ClockResetBase + 0x64)
#define INT_CLR         (ClockResetBase + 0x68)

#define HW_WDTBase      0x40011000
#define WDG_LDR         (HW_WDTBase + 0x000)
#define WDG_VLR         (HW_WDTBase + 0x004)
#define WDG_CTL         (HW_WDTBase + 0x008)
#define WDG_ICL         (HW_WDTBase + 0x00c)
#define WDG_RIS         (HW_WDTBase + 0x010)
#define WDG_LCK         (HW_WDTBase + 0xc00)

#define USE_CH3
/* #define USE_CH4 */
#ifdef USE_CH3
#define MFSBase         0x40038300              // MFS ch.3
#endif
#ifdef USE_CH4
#define MFSBase         0x40038400              // MFS ch.4
#endif
#define MFS_SMR         (MFSBase + 0x00)
#define MFS_SCR         (MFSBase + 0x01)
#define MFS_ESCR        (MFSBase + 0x04)
#define MFS_SSR         (MFSBase + 0x05)
#define MFS_TDR_RDR     (MFSBase + 0x08)
#define MFS_BGR         (MFSBase + 0x0c)
#define MFS_FCR0        (MFSBase + 0x14)
#define MFS_FCR1        (MFSBase + 0x15)
#define MFS_FBYTE1      (MFSBase + 0x18)
#define MFS_FBYTE2      (MFSBase + 0x19)

#define GPIOBase        0x40033000
#define GPIO_PFR0       (GPIOBase + 0x000)
#define GPIO_PFR1       (GPIOBase + 0x004)
#define GPIO_PFR2       (GPIOBase + 0x008)
#define GPIO_PFR3       (GPIOBase + 0x00C)
#define GPIO_PFR4       (GPIOBase + 0x010)
#define GPIO_PFR5       (GPIOBase + 0x014)
#define GPIO_PFR6       (GPIOBase + 0x018)
#define GPIO_PFR7       (GPIOBase + 0x01C)
#define GPIO_PFR8       (GPIOBase + 0x020)
#define GPIO_PFR9       (GPIOBase + 0x024)
#define GPIO_PFRA       (GPIOBase + 0x028)
#define GPIO_PFRB       (GPIOBase + 0x02C)
#define GPIO_PFRC       (GPIOBase + 0x030)
#define GPIO_PFRD       (GPIOBase + 0x034)
#define GPIO_PFRE       (GPIOBase + 0x038)
#define GPIO_PFRF       (GPIOBase + 0x03C)
#define GPIO_PCR0       (GPIOBase + 0x100)
#define GPIO_PCR1       (GPIOBase + 0x104)
#define GPIO_PCR2       (GPIOBase + 0x108)
#define GPIO_PCR3       (GPIOBase + 0x10C)
#define GPIO_PCR4       (GPIOBase + 0x110)
#define GPIO_PCR5       (GPIOBase + 0x114)
#define GPIO_PCR6       (GPIOBase + 0x118)
#define GPIO_PCR7       (GPIOBase + 0x11C)
#define GPIO_PCR9       (GPIOBase + 0x124)
#define GPIO_PCRA       (GPIOBase + 0x128)
#define GPIO_PCRB       (GPIOBase + 0x12C)
#define GPIO_PCRC       (GPIOBase + 0x130)
#define GPIO_PCRD       (GPIOBase + 0x134)
#define GPIO_PCRE       (GPIOBase + 0x138)
#define GPIO_PCRF       (GPIOBase + 0x13C)
#define GPIO_DDR0       (GPIOBase + 0x200)
#define GPIO_DDR1       (GPIOBase + 0x204)
#define GPIO_DDR2       (GPIOBase + 0x208)
#define GPIO_DDR3       (GPIOBase + 0x20C)
#define GPIO_DDR4       (GPIOBase + 0x210)
#define GPIO_DDR5       (GPIOBase + 0x214)
#define GPIO_DDR6       (GPIOBase + 0x218)
#define GPIO_DDR7       (GPIOBase + 0x21C)
#define GPIO_DDR8       (GPIOBase + 0x220)
#define GPIO_DDR9       (GPIOBase + 0x224)
#define GPIO_DDRA       (GPIOBase + 0x228)
#define GPIO_DDRB       (GPIOBase + 0x22C)
#define GPIO_DDRC       (GPIOBase + 0x230)
#define GPIO_DDRD       (GPIOBase + 0x234)
#define GPIO_DDRE       (GPIOBase + 0x238)
#define GPIO_DDRF       (GPIOBase + 0x23C)
#define GPIO_PDIR0      (GPIOBase + 0x300)
#define GPIO_PDIR1      (GPIOBase + 0x304)
#define GPIO_PDIR2      (GPIOBase + 0x308)
#define GPIO_PDIR3      (GPIOBase + 0x30C)
#define GPIO_PDIR4      (GPIOBase + 0x310)
#define GPIO_PDIR5      (GPIOBase + 0x314)
#define GPIO_PDIR6      (GPIOBase + 0x318)
#define GPIO_PDIR7      (GPIOBase + 0x31C)
#define GPIO_PDIR8      (GPIOBase + 0x320)
#define GPIO_PDIR9      (GPIOBase + 0x324)
#define GPIO_PDIRA      (GPIOBase + 0x328)
#define GPIO_PDIRB      (GPIOBase + 0x32C)
#define GPIO_PDIRC      (GPIOBase + 0x330)
#define GPIO_PDIRD      (GPIOBase + 0x334)
#define GPIO_PDIRE      (GPIOBase + 0x338)
#define GPIO_PDIRF      (GPIOBase + 0x33C)
#define GPIO_PDOR0      (GPIOBase + 0x400)
#define GPIO_PDOR1      (GPIOBase + 0x404)
#define GPIO_PDOR2      (GPIOBase + 0x408)
#define GPIO_PDOR3      (GPIOBase + 0x40C)
#define GPIO_PDOR4      (GPIOBase + 0x410)
#define GPIO_PDOR5      (GPIOBase + 0x414)
#define GPIO_PDOR6      (GPIOBase + 0x418)
#define GPIO_PDOR7      (GPIOBase + 0x41C)
#define GPIO_PDOR8      (GPIOBase + 0x420)
#define GPIO_PDOR9      (GPIOBase + 0x424)
#define GPIO_PDORA      (GPIOBase + 0x428)
#define GPIO_PDORB      (GPIOBase + 0x42C)
#define GPIO_PDORC      (GPIOBase + 0x430)
#define GPIO_PDORD      (GPIOBase + 0x434)
#define GPIO_PDORE      (GPIOBase + 0x438)
#define GPIO_PDORF      (GPIOBase + 0x43C)
#define GPIO_ADE        (GPIOBase + 0x500)
#define GPIO_SPSR       (GPIOBase + 0x580)
#define GPIO_EPFR00     (GPIOBase + 0x600)
#define GPIO_EPFR01     (GPIOBase + 0x604)
#define GPIO_EPFR02     (GPIOBase + 0x608)
#define GPIO_EPFR03     (GPIOBase + 0x60C)
#define GPIO_EPFR04     (GPIOBase + 0x610)
#define GPIO_EPFR05     (GPIOBase + 0x614)
#define GPIO_EPFR06     (GPIOBase + 0x618)
#define GPIO_EPFR07     (GPIOBase + 0x61C)
#define GPIO_EPFR08     (GPIOBase + 0x620)
#define GPIO_EPFR09     (GPIOBase + 0x624)
#define GPIO_EPFR10     (GPIOBase + 0x628)
#define GPIO_EPFR11     (GPIOBase + 0x62C)
#define GPIO_EPFR12     (GPIOBase + 0x630)
#define GPIO_EPFR13     (GPIOBase + 0x634)
#define GPIO_EPFR14     (GPIOBase + 0x638)
#define GPIO_EPFR15     (GPIOBase + 0x63C)
#define GPIO_PZR0       (GPIOBase + 0x700)
#define GPIO_PZR1       (GPIOBase + 0x704)
#define GPIO_PZR2       (GPIOBase + 0x708)
#define GPIO_PZR3       (GPIOBase + 0x70C)
#define GPIO_PZR4       (GPIOBase + 0x710)
#define GPIO_PZR5       (GPIOBase + 0x714)
#define GPIO_PZR6       (GPIOBase + 0x718)
#define GPIO_PZR7       (GPIOBase + 0x71C)
#define GPIO_PZR8       (GPIOBase + 0x720)
#define GPIO_PZR9       (GPIOBase + 0x724)
#define GPIO_PZRA       (GPIOBase + 0x728)
#define GPIO_PZRB       (GPIOBase + 0x72C)
#define GPIO_PZRC       (GPIOBase + 0x730)
#define GPIO_PZRD       (GPIOBase + 0x734)
#define GPIO_PZRE       (GPIOBase + 0x738)
#define GPIO_PZRF       (GPIOBase + 0x73C)
